package com.supervision.vo.manage;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Data
public class TreeNode {

   private String id;

   private String name;

   private List<TreeNode> child;


   public TreeNode() {
   }

   public TreeNode(String id, String name) {
      this.id = id;
      this.name = name;
   }

   @JsonIgnore
   public List<TreeNode> getOrDefaultChild(){
      if (null == child){
         child = new ArrayList<>();
      }
      return child;
   }

   public TreeNode findChildByName(String name){
      if (CollUtil.isEmpty(child) || StrUtil.isEmpty(name)){
         return null;
      }

     return child.stream().filter(node -> name.equals(node.getName())).findFirst().orElse(null);


   }
}
